Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deSceneTerrain Class Reference

`#include <deScene_priv.hpp>`

Inheritance diagram for deSceneTerrain:

[legend]
Collaboration diagram for deSceneTerrain:

[legend]
List of all members.

## Public Member Functions
| deSceneTerrain ()
IdeSceneObject::interface_t | GetSOIType ()
void * | GetSOInterface (IdeSceneObject::interface_t i)
deBoolean | DeSerializeLoad ()
void | PreCache (IdeDriver *pDriver)
deBoolean | SetTerrainHeightMap (IdeBitmapProxy *bmp)
deBoolean | SetTerrainColorMap (IdeBitmapProxy *bmp)
deBoolean | SetTerrainDetailMap (IdeBitmapProxy *bmp)
deVec3d | GetTerrainScale ()
void | SetTerrainScale (deVec3d vScale)
void | SetTerrainScale (deFloat x, deFloat y, deFloat z)
deTexCoord | GetDetailRepeat ()
void | SetDetailRepeat (deTexCoord Repeat)
void | SetDetailRepeat (deFloat u, deFloat v)
void | SetHeightAt (unsigned char ucHeight, long x, long y)
unsigned char | GetTrueHeightAt (long x, long y)
deFloat | GetScaledHeightAt (long x, long y)
deDouble | GetLODBias ()
void | SetLODBias (deDouble Bias)
deBoolean | BuildRenderable ()
long | GetGMMChunkSize ()
void | SetGMMChunkSize (long ChunkSize)
deBoolean | BuildGeoMipMap (IdeDriver *pDriver)
## Public Attributes
| WorldObjectClassDef
## Protected Member Functions
virtual | ~deSceneTerrain ()
## Private Member Functions
long | TraverseForRender (IdeSceneGraph::deSceneTraversal *Params)
deBoolean | TestRoomCollision (const IdeCollision::deCollideParams &Params, IdeCollision *Collision)
deBoolean | CreateTerrainTexture (IdeDriver *pDriver)
int | GetGMMChunkNumber (long x, long z)
void | ResetGMMChunks ()
deBoolean | BuildGMMQuadtree ()
deBoolean | BuildGMMQuadrant (deTerrainGMMQuadrant *Parent, long StartX, long StartZ, long StopX, long StopZ)
void | DestroyGMMQuadrant (deTerrainGMMQuadrant *&Quadrant)
deBoolean | RenderGMMChunk (const deTerrainGMMChunk *Chunk, IdeSceneGraph::deSceneTraversal *Params, const deTransform &WorldTransform)
deBoolean | BuildGMMChunk (long x, long z, IdeDriver *pDriver)
void | DestroyGMMChunk (deTerrainGMMChunk *Chunk)
deBoolean | RenderVisibleGMMChunks (deTerrainGMMQuadrant *Quadrant, IdeSceneGraph::deSceneTraversal *Params, const deTransform &WorldTransform, deBoolean AllVisible)
## Private Attributes
deVec3d | m_Scale
deTexCoord | m_DetailRepeat
IdeBitmapProxy * | m_HeightMap
IdeBitmapProxy * | m_ColorMap
IdeBitmapProxy * | m_DetailMap
IdeRenderTexture * | m_RenderTexture
deTArray< IdeVertexBuffer * > | m_VBuffers
deTArray< IdeVertexBuffer * > | m_IndexBuffers
deTerrainGMMChunk * | m_GMMChunks
deTerrainGMMQuadrant * | m_GMMRoot
long | m_GMMChunkSize
long | m_GMMChunksXSide
long | m_GMMChunksZSide
deDouble | m_LODBias

## Constructor & Destructor Documentation

deSceneTerrain::~deSceneTerrain | ( |  | ) | `[protected, virtual]`

deSceneTerrain::deSceneTerrain | ( |  | ) |

## Member Function Documentation

deBoolean deSceneTerrain::BuildGeoMipMap | ( | IdeDriver * | pDriver | ) | `[virtual]`

| Implements IdeSceneTerrain.

deBoolean deSceneTerrain::BuildGMMChunk | ( | long | x,
|  | long | z,
|  | IdeDriver * | pDriver
| ) | `[private]`

deBoolean deSceneTerrain::BuildGMMQuadrant | ( | deTerrainGMMQuadrant * | Parent,
|  | long | StartX,
|  | long | StartZ,
|  | long | StopX,
|  | long | StopZ
| ) | `[private]`

deBoolean deSceneTerrain::BuildGMMQuadtree | ( |  | ) | `[private]`

deBoolean deSceneTerrain::BuildRenderable | ( |  | ) | `[virtual]`

| Implements IdeSceneTerrain.

deBoolean deSceneTerrain::CreateTerrainTexture | ( | IdeDriver * | pDriver | ) | `[private]`

deBoolean deSceneTerrain::DeSerializeLoad | ( |  | ) | `[virtual]`

| Call after all objects in a world have been loaded, to allow pointers to be correctly resolved from World and Object ID's Reimplemented from deSceneObject.

void deSceneTerrain::DestroyGMMChunk | ( | deTerrainGMMChunk * | Chunk | ) | `[private]`

void deSceneTerrain::DestroyGMMQuadrant | ( | deTerrainGMMQuadrant *& | Quadrant | ) | `[private]`

deTexCoord deSceneTerrain::GetDetailRepeat | ( |  | ) | `[virtual]`

| Implements IdeSceneTerrain.

int deSceneTerrain::GetGMMChunkNumber | ( | long | x,
|  | long | z
| ) | `[private]`

long deSceneTerrain::GetGMMChunkSize | ( |  | ) | `[virtual]`

| Implements IdeSceneTerrain.

deDouble deSceneTerrain::GetLODBias | ( |  | ) | `[virtual]`

| Implements IdeSceneTerrain.

deFloat deSceneTerrain::GetScaledHeightAt | ( | long | x,
|  | long | y
| ) | `[virtual]`

| Implements IdeSceneTerrain.

void* deSceneTerrain::GetSOInterface | ( | IdeSceneObject::interface_t | i | ) | `[virtual]`

| Reimplemented from deSceneObject.

IdeSceneObject::interface_t deSceneTerrain::GetSOIType | ( |  | ) | `[virtual]`

| Reimplemented from deSceneObject.

deVec3d deSceneTerrain::GetTerrainScale | ( |  | ) | `[virtual]`

| Implements IdeSceneTerrain.

unsigned char deSceneTerrain::GetTrueHeightAt | ( | long | x,
|  | long | y
| ) | `[virtual]`

| Implements IdeSceneTerrain.

void deSceneTerrain::PreCache | ( | IdeDriver * | pDriver | ) | `[virtual]`

| Reimplemented from deSceneObject.

deBoolean deSceneTerrain::RenderGMMChunk | ( | const deTerrainGMMChunk * | Chunk,
|  | IdeSceneGraph::deSceneTraversal * | Params,
|  | const deTransform & | WorldTransform
| ) | `[private]`

deBoolean deSceneTerrain::RenderVisibleGMMChunks | ( | deTerrainGMMQuadrant * | Quadrant,
|  | IdeSceneGraph::deSceneTraversal * | Params,
|  | const deTransform & | WorldTransform,
|  | deBoolean | AllVisible
| ) | `[private]`

void deSceneTerrain::ResetGMMChunks | ( |  | ) | `[private]`

void deSceneTerrain::SetDetailRepeat | ( | deFloat | u,
|  | deFloat | v
| ) | `[virtual]`

| Implements IdeSceneTerrain.

void deSceneTerrain::SetDetailRepeat | ( | deTexCoord | Repeat | ) | `[virtual]`

| Implements IdeSceneTerrain.

void deSceneTerrain::SetGMMChunkSize | ( | long | ChunkSize | ) | `[virtual]`

| Implements IdeSceneTerrain.

void deSceneTerrain::SetHeightAt | ( | unsigned char | ucHeight,
|  | long | x,
|  | long | y
| ) | `[virtual]`

| Implements IdeSceneTerrain.

void deSceneTerrain::SetLODBias | ( | deDouble | Bias | ) | `[virtual]`

| Implements IdeSceneTerrain.

deBoolean deSceneTerrain::SetTerrainColorMap | ( | IdeBitmapProxy * | bmp | ) | `[virtual]`

| Implements IdeSceneTerrain.

deBoolean deSceneTerrain::SetTerrainDetailMap | ( | IdeBitmapProxy * | bmp | ) | `[virtual]`

| Implements IdeSceneTerrain.

deBoolean deSceneTerrain::SetTerrainHeightMap | ( | IdeBitmapProxy * | bmp | ) | `[virtual]`

| Implements IdeSceneTerrain.

void deSceneTerrain::SetTerrainScale | ( | deFloat | x,
|  | deFloat | y,
|  | deFloat | z
| ) | `[virtual]`

| Implements IdeSceneTerrain.

void deSceneTerrain::SetTerrainScale | ( | deVec3d | vScale | ) | `[virtual]`

| Implements IdeSceneTerrain.

deBoolean deSceneTerrain::TestRoomCollision | ( | const IdeCollision::deCollideParams & | Params,
|  | IdeCollision * | Collision
| ) | `[private]`

long deSceneTerrain::TraverseForRender | ( | IdeSceneGraph::deSceneTraversal * | Params | ) | `[private, virtual]`

| Implements deSceneObject.

## Member Data Documentation

IdeBitmapProxy* deSceneTerrain::m_ColorMap`[private]`

IdeBitmapProxy* deSceneTerrain::m_DetailMap`[private]`

deTexCoord deSceneTerrain::m_DetailRepeat`[private]`

deTerrainGMMChunk* deSceneTerrain::m_GMMChunks`[private]`

long deSceneTerrain::m_GMMChunkSize`[private]`

long deSceneTerrain::m_GMMChunksXSide`[private]`

long deSceneTerrain::m_GMMChunksZSide`[private]`

deTerrainGMMQuadrant* deSceneTerrain::m_GMMRoot`[private]`

IdeBitmapProxy* deSceneTerrain::m_HeightMap`[private]`

deTArray<IdeVertexBuffer*> deSceneTerrain::m_IndexBuffers`[private]`

deDouble deSceneTerrain::m_LODBias`[private]`

IdeRenderTexture* deSceneTerrain::m_RenderTexture`[private]`

deVec3d deSceneTerrain::m_Scale`[private]`

deTArray<IdeVertexBuffer*> deSceneTerrain::m_VBuffers`[private]`

deSceneTerrain::WorldObjectClassDef

The documentation for this class was generated from the following files:

- deScene_priv.hpp
- deTerrain.cpp